/*
 * mondo-filelistchop.c 
 * Copyright 2000, Hugo Rabson <hugo@firstlinux.net>
 * Mondo-filelistchop is licensed under the GNU General Public License
 * This file is part of the Mondo CD archive/recovery suite;
 * purpose is to chop the filelist into N Mb sets _and_ write a list
 * of really big files to a separate list
 * 
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <getopt.h>
#include <errno.h>


long size_of_file(char *fname)
{
  long len;
  FILE *ftemp;
  struct stat buf;
  if (strstr(fname,"/dev/")!=(int)NULL)
    {
      return(1);
    }
  if (lstat(fname,&buf)!=0)
    {
      return(0);
    }
  len=buf.st_size>>10;
  return(len);
}



int main(int argc,char *argv[])
{
  long maxsetsizeK,
    curr_set_size,
    siz;
  int i,curr_set_no;
  char filelist[1000], 
    outdir[1000], 
    outfname[1000], 
    biggie_fname[1000], 
    incoming[1000];
  FILE*fin,
    *fout,
    *fbig;

  //  printf("%ld\n",size_of_file(argv[1]));
  //  return(0);

  //printf("mondo-filelistchop ------------------ Hugo Rabson\n");

  // argv[0] is the program's name; argv[1-3] are the params;
  // so, if we're given 3 cool parameters, argc==4 :-)
  if ( argc != 4 ) {
    printf("mondo-filelistchop <filelist> <outdir> <setsizeK>\n");
    return(1);
  }
  strncpy(filelist,argv[1],255);
  strncpy(outdir,argv[2],255);
  maxsetsizeK=atol(argv[3]);
  fin=fopen(filelist,"r");
  curr_set_no=0;
  curr_set_size=0;
  sprintf(outfname,"%s/filelist.%d",outdir,curr_set_no);
  sprintf(biggie_fname,"%s/biggielist.txt",outdir);
  fbig=fopen(biggie_fname,"w");
  if (fbig==NULL)
    {
      printf("unable to open %s\n",biggie_fname);
      return 1;
    }
  printf("outfname = %s\n",outfname);
  fout=fopen(outfname,"w");
  //printf("Creating fileset 0...\r");
  fgets(incoming,999,fin);
  while (!feof(fin))
    {
      i=strlen(incoming)-1;
      if (i<0) {i=0;}
      if (incoming[i]<32) {incoming[i]='\0';}
      siz=size_of_file(incoming);
      if (siz > maxsetsizeK)
	{
	  fprintf(fbig,"%s\n",incoming);
	}
      else
	{
	  curr_set_size+=siz;
	  fprintf(fout,"%s\n",incoming);
	  if (curr_set_size > maxsetsizeK)
	    {
	      fclose(fout);
	      curr_set_no++;
	      curr_set_size=0;
	    sprintf(outfname,"%s/filelist.%d",outdir,curr_set_no);
	    fout=fopen(outfname,"w");
	    printf("\t\t\t\tFileset %d chopped.\n",curr_set_no-1);
	    }
	}
      fgets(incoming,999,fin);
    }
  fclose(fin);
  fclose(fout);
  fclose(fbig);
  printf("\t\t\t\tAll %d filesets chopped. \n",curr_set_no);
  return(0);
}

